#!/usr/bin/env python
#
#   This script will call the SentiStrength Web service with the text from 
#   the 1000 tweets and write a JSON file with tweets and the SentiStrength.
#
# $Id: Nielsen2011New_sentistrength.py,v 1.1 2011/03/13 19:12:46 fn Exp $

import csv
import re
import numpy as np
import pylab
import random
from scipy import sparse
from scipy.stats.stats import  kendalltau, spearmanr
import simplejson
import sys
reload(sys)
sys.setdefaultencoding('utf-8')

from time             import sleep, time
from urllib           import FancyURLopener, urlencode, urlretrieve
from xml.sax.saxutils import unescape as unescape_saxutils


class MyOpener(FancyURLopener):
    version = 'RBBBot, Finn Aarup Nielsen (http://www.imm.dtu.dk/~fn/, fn@imm.dtu.dk)'



# This variable determines the data set
mislove = 2

# Filenames
filebase = '/home/fn/'
filename_afinn = filebase + 'fnielsen/data/Nielsen2009Responsible_emotion.csv'
filename_mislove1 = "results.txt"
filename_mislove2a = "turk.txt"
filename_mislove2b = "turk-results.txt"


urlbase = "http://sentistrength.wlv.ac.uk/results.php?"

pattern_positive = re.compile("positive strength <b>(\d)</b>")
pattern_negative = re.compile("negative strength <b>(\-\d)</b>")


# Word splitter pattern
pattern_split = re.compile(r"\W+")

myopener = MyOpener()

# Read Mislove CSV Twitter data: 'tweets' an array of dictionaries
if mislove == 1:
    csv_reader = csv.reader(open(filename_mislove1), delimiter='\t')
    header = []
    tweets = []
    for row in csv_reader:
        if not header:
            header = row
        else:
            tweets.append({'id': row[0], 
                           'quant': int(row[1]), 
                           'score_our': float(row[2]),
                           'score_mean': float(row[3]),
                           'score_std': float(row[4]),
                           'text': row[5], 
                           'scores': map(int, row[6:])})
elif mislove == 2:
    csv_reader = csv.reader(open(filename_mislove2a), delimiter='\t')
    tweets = []
    for row in csv_reader:
        tweets.append({'id': row[2], 
                       'score_mislove2': float(row[1]),
                       'text': row[3]})
    csv_reader = csv.reader(open(filename_mislove2b), delimiter='\t')
    tweets_dict = {}
    header = []
    for row in csv_reader:
        if not header:
            header = row
        else:
            tweets_dict[row[0]] = {'id': row[0], 
                                   'score_mislove': float(row[1]), 
                                   'score_amt_wrong': float(row[2]),
                                   'score_amt': np.mean(map(int, re.split("\s+", " ".join(row[4:]).strip())))
                                   }
    for n in range(len(tweets)):
        tweets[n]['score_mislove'] = tweets_dict[tweets[n]['id']]['score_mislove']
        tweets[n]['score_amt_wrong'] = tweets_dict[tweets[n]['id']]['score_amt_wrong']
        tweets[n]['score_amt'] = tweets_dict[tweets[n]['id']]['score_amt']




for n in range(len(tweets)):
    url = urlbase + urlencode({'text': tweets[n]['text']})
    try:
        html = myopener.open(url).read()
        positive = int(pattern_positive.findall(html)[0])
        negative = int(pattern_negative.findall(html)[0])
        tweets[n]['sentistrength_positive'] = positive
        tweets[n]['sentistrength_negative'] = negative
        if positive > abs(negative):
            tweets[n]['sentistrength'] = positive
        elif abs(negative) > positive:
            tweets[n]['sentistrength'] = negative
        else:
            tweets[n]['sentistrength'] = 0
    except Exception, e: 
        error = str(e)
        tweets[n]['sentistrength_error'] = error
    print(n)
        

simplejson.dump(tweets, open("tweets_with_sentistrength.json", "w")) 
